<?php
/*
Plugin Name: درگاه پرداخت شرکت پرداخت الکترونیک سپهر Restrict Content Pro
Version: 2.0.0
Description:  درگاه پرداخت شرکت پرداخت الکترونیک سپهر Restrict Content Pro
Plugin URI: http://www.softiran.org
Author URI: http:/www.softiran.org
*/
if (!defined('ABSPATH')) exit;

if (!class_exists('RCP_pas') ) {
	class RCP_pas {
	
		public function __construct() {
			add_action('init', array($this, 'pas_Verify'));
			add_action('rcp_payments_settings', array($this, 'pas_Setting'));
			add_action('rcp_gateway_pas', array($this, 'pas_Request'));
			add_filter('rcp_payment_gateways', array($this, 'pas_Register'));
			if (!function_exists('RCP_IRAN_Currencies') && !function_exists('RCP_IRAN_Currencies'))
				add_filter('rcp_currencies', array($this, 'RCP_IRAN_Currencies'));
		}

		public function RCP_IRAN_Currencies( $currencies ) {
			unset($currencies['RIAL']);
			$currencies['تومان'] = __('تومان', 'rcp_pas');
			$currencies['ریال'] = __('ریال', 'rcp_pas');
			return $currencies;
		}
				
		public function pas_Register($gateways) {
			global $rcp_options;
			
			if( version_compare( RCP_PLUGIN_VERSION, '2.1.0', '<' ) ) {
				$gateways['pas'] = isset($rcp_options['pas_name']) ? $rcp_options['pas_name'] : __( 'پرداخت الکترونیک سپهر', 'rcp_pas');
			}
			else {
				$gateways['pas'] = array(
					'label' => isset($rcp_options['pas_name']) ? $rcp_options['pas_name'] : __( 'پرداخت الکترونیک سپهر', 'rcp_pas'),
					'admin_label' => isset($rcp_options['pas_name']) ? $rcp_options['pas_name'] : __( 'پرداخت الکترونیک سپهر', 'rcp_pas'),
				);
			}
			
			return $gateways;
		}

		public function pas_Setting($rcp_options) {
		?>	
			<hr/>
			<table class="form-table">
				<?php do_action( 'RCP_pas_before_settings', $rcp_options ); ?>
				<tr valign="top">
					<th colspan=2><h3><?php _e( 'تنظیمات پرداخت الکترونیک سپهر', 'rcp_pas' ); ?></h3></th>
				</tr>
				
				<tr valign="top">
					<th>
						<label for="rcp_settings[pas_terminal]"><?php _e( 'ترمینال آی دی', 'rcp_pas' ); ?></label>
					</th>
					<td>
						<input class="regular-text" id="rcp_settings[pas_terminal]" style="width: 300px;" name="rcp_settings[pas_terminal]" value="<?php if( isset( $rcp_options['pas_terminal'] ) ) { echo $rcp_options['pas_terminal']; } ?>"/>
					</td>
				</tr>				
				<tr valign="top">
					<th>
						<label for="rcp_settings[pas_query_name]"><?php _e( 'نام لاتین درگاه', 'rcp_pas' ); ?></label>
					</th>
					<td>
						<input class="regular-text" id="rcp_settings[pas_query_name]" style="width: 300px;" name="rcp_settings[pas_query_name]" value="<?php echo isset($rcp_options['pas_query_name']) ? $rcp_options['pas_query_name'] : 'pas'; ?>"/>
						<div class="description"><?php _e( 'این نام در هنگام بازگشت از بانک در آدرس بازگشت از بانک نمایان خواهد شد . از به کاربردن حروف زائد و فاصله جدا خودداری نمایید . این نام باید با نام سایر درگاه ها متفاوت باشد .', 'rcp_pas' ); ?></div>
					</td>
				</tr>
				<tr valign="top">
					<th>
						<label for="rcp_settings[pas_name]"><?php _e( 'نام نمایشی درگاه', 'rcp_pas' ); ?></label>
					</th>
					<td>
						<input class="regular-text" id="rcp_settings[pas_name]" style="width: 300px;" name="rcp_settings[pas_name]" value="<?php echo isset($rcp_options['pas_name']) ? $rcp_options['pas_name'] : __( 'پرداخت الکترونیک سپهر', 'rcp_pas'); ?>"/>
					</td>
				</tr>
				<tr valign="top">
					<th>
						<label><?php _e( 'تذکر ', 'rcp_pas' ); ?></label>
					</th>
					<td>
						<div class="description"><?php _e( 'از سربرگ مربوط به ثبت نام در تنظیمات افزونه حتما یک برگه برای بازگشت از بانک انتخاب نمایید . ترجیحا نامک برگه را لاتین قرار دهید .<br/> نیازی به قرار دادن شورت کد خاصی در برگه نیست و میتواند برگه ی خالی باشد .', 'rcp_pas' ); ?></div>
					</td>
				</tr>
				<?php do_action( 'RCP_pas_after_settings', $rcp_options ); ?>
			</table>
			<?php
		}
		
		public function pas_Request($subscription_data) {
				
			$new_subscription_id = get_user_meta( $subscription_data['user_id'], 'rcp_subscription_level' , true );
			if ( !empty( $new_subscription_id )) {
				update_user_meta( $subscription_data['user_id'], 'rcp_subscription_level_new', $new_subscription_id );
			}
			
			$old_subscription_id = get_user_meta( $subscription_data['user_id'], 'rcp_subscription_level_old' , true );
			if ( !empty( $old_subscription_id )) {
				update_user_meta( $subscription_data['user_id'], 'rcp_subscription_level', $old_subscription_id );
			}
			
			global $rcp_options;
			ob_start();
			$query = isset($rcp_options['pas_query_name']) ? $rcp_options['pas_query_name'] : 'pas';
			$amount = str_replace( ',', '', $subscription_data['price']);
			//fee is just for paypal recurring or ipn gateway ....
			//$amount = $subscription_data['price'] + $subscription_data['fee']; 

			$pas_payment_data = array(
				'user_id'             => $subscription_data['user_id'],
				'subscription_name'     => $subscription_data['subscription_name'],
				'subscription_key'	 => $subscription_data['key'],
				'amount'           => $amount
			);			
			
			@session_start();

			$_SESSION["pas_payment_data"] = json_encode($pas_payment_data);	
			
			//Action For pas or RCP Developers...
			do_action( 'RCP_Before_Sending_to_pas', $subscription_data );	
		
			if ($rcp_options['currency'] == 'ریال' || $rcp_options['currency'] == 'RIAL' || $rcp_options['currency'] == 'ریال ایران' || $rcp_options['currency'] == 'Iranian Rial (&#65020;)')
				$amount = $amount;
			else
				$amount = $amount * 10;
			

			$terminal = isset($rcp_options['pas_terminal']) ? $rcp_options['pas_terminal'] : '';
			$Amount = intval($amount);
			$CallbackURL =  add_query_arg('gateway', $query, $subscription_data['return_url']);
			$Description = sprintf(__('خرید اشتراک %s برای کاربر %s', 'rcp_pas'), $subscription_data['subscription_name'],$subscription_data['user_name']);
			
			$Description = apply_filters( 'RCP_pas_Description', $Description, $subscription_data );
			$Description = urlencode($Description);
						
			
			
			$amount = trim($Amount);

			$invoiceNumber = time();
			$merchant = $ApiID;
			$redirectAddress = $CallbackURL; 
			$terminal = $terminal;
			$source = $amount.$invoiceNumber.$merchant.$redirectAddress.$terminal;
			
			$params ='terminalID='.$terminal.'&Amount='.$amount.'&callbackURL='.urlencode($redirectAddress).'&invoiceID='.$invoiceNumber;
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, 'https://mabna.shaparak.ir:8081/V1/PeymentApi/GetToken');
			curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			$res = curl_exec($ch);
			curl_close($ch);
			if($res)
			{
				$res = json_decode($res,true);
				if($res['Status'] == '0')
				{	  
					echo '<form id="paymentUTLfrm" action="https://mabna.shaparak.ir:8080" method="POST">
						<input type="hidden" id="TerminalID" name="TerminalID" value="'.$terminal.'">
						<input type="hidden" id="token" name="token" value="'.$res['Accesstoken'].'">
						</form><script>
						function submitmabna() {
						document.getElementById("paymentUTLfrm").submit();
						}
						window.onload=submitmabna; </script>';
						die;
				}else
				{
					echo ('خطا در ساخت توکن <br/> کد خطا :'.$res['Status']);
					die;
				}
			}
			else
			{
				echo ('پورت 8081 در هاست شما بسته است !');
				die;
			}
		}
		
		public function pas_Verify() {
			
			if (!isset($_GET['gateway']))
				return;
			
			if ( !class_exists('RCP_Payments') )
				return;
			
			global $rcp_options, $wpdb, $rcp_payments_db_name;
			@session_start();
			$pas_payment_data = isset($_SESSION["pas_payment_data"]) ? json_decode($_SESSION["pas_payment_data"],true) : '';
			
			$query = isset($rcp_options['pas_query_name']) ? $rcp_options['pas_query_name'] : 'pas';
						
			if 	( ($_GET['gateway'] == $query) && $pas_payment_data )
			{
				
				$user_id 			= $pas_payment_data['user_id'];
				$subscription_name 	= $pas_payment_data['subscription_name'];
				$subscription_key 	= $pas_payment_data['subscription_key'];
				$amount 			= $pas_payment_data['amount'];
				
				/*
				$subscription_price = intval(number_format( (float) rcp_get_subscription_price( rcp_get_subscription_id( $user_id ) ), 2)) ;
				*/
				
				$subscription_id    = rcp_get_subscription_id( $user_id );
				$user_data          = get_userdata( $user_id );
				$payment_method =  isset($rcp_options['pas_name']) ? $rcp_options['pas_name'] : __( 'پرداخت الکترونیک سپهر', 'rcp_pas');
				
				
				
				$new_payment = 1;
				if( $wpdb->get_results( $wpdb->prepare("SELECT id FROM " . $rcp_payments_db_name . " WHERE `subscription_key`='%s' AND `payment_type`='%s';", $subscription_key, $payment_method ) ) )
					$new_payment = 0;

				unset($GLOBALS['pas_new']);
				$GLOBALS['pas_new'] = $new_payment;
				global $new;
				$new = $new_payment;
			
				if ($new_payment == 1) 
				{
				
					
					$terminal = isset($rcp_options['pas_terminal']) ? $rcp_options['pas_terminal'] : '';
					$Amount = intval($amount);
					if ($rcp_options['currency'] == 'ریال' || $rcp_options['currency'] == 'RIAL' || $rcp_options['currency'] == 'ریال ایران' || $rcp_options['currency'] == 'Iranian Rial (&#65020;)')
						$Amount = $Amount;
					else
						$Amount = $Amount * 10;
									
					
					if( isset($_POST['respcode']) && $_POST['respcode'] == '0' )
					{

						$postmeta = $wpdb->get_row($wpdb->prepare("SELECT count(*) as cc  FROM " . $rcp_payments_db_name . " WHERE transaction_id = %s LIMIT 1",$_POST['digitalreceipt']));

						if($postmeta->cc <= 0)
						{
							$referenceId=$_POST['digitalreceipt'];
							$referenceId2=$_POST['rrn'];
							$params ='digitalreceipt='.$_POST['digitalreceipt'].'&Tid='.$terminal;
							$ch = curl_init();
							curl_setopt($ch, CURLOPT_URL, 'https://mabna.shaparak.ir:8081/V1/PeymentApi/Advice');
							curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
							curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
							curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
							$res = curl_exec($ch);
							curl_close($ch);
							$result = json_decode($res,true);
							if (strtoupper($result['Status']) == 'OK') 
							{
								if( floatval($result['ReturnId']) == floatval($Amount) )
								{
									$transaction_id = $_POST['digitalreceipt'];
									$transaction_id2 = $referenceId2;
									$payment_status = 'completed';
									$fault = 0;
								}
								else
								{
									$payment_status = 'failed';
									$transaction_id = $referenceId;
									$fault = "مبلغ پرداختی صحیح نیست" ;
								}
								
							}else
							{

								switch($result['ReturnId'])
								{
									case '-1' : $err = 'تراکنش پیدا نشد';break;
									case '-2' : $err = 'تراکنش قبلا Reverse شده است';break;
									case '-3' : $err = 'خطا عمومی';break;
									case '-4' : $err = 'امکان انجام درخواست برای این تراکنش وجود ندارد';break;
									case '-5' : $err = 'آدرس IP پذیرنده نامعتبر است';break;
									default  : $err = 'خطای ناشناس : '.$result['ReturnId'];break;
									
								}
								$payment_status = 'failed';
								$transaction_id = $referenceId;
								$fault = $err ;
							}

						}
						else
						{
							$payment_status = 'failed';
							$transaction_id = $referenceId;
							$fault ='رسید قبلا استفاده شده است';

						}
					
					}
					else
					{
						$payment_status = 'failed';
						$transaction_id = $referenceId;
						$fault = $_POST['respmsg'];

					}
					
					
					//End of pas
				
			
					unset($GLOBALS['pas_payment_status']);
					unset($GLOBALS['pas_transaction_id']);
					unset($GLOBALS['pas_fault']);
					unset($GLOBALS['pas_subscription_key']);
					$GLOBALS['pas_payment_status'] = $payment_status;
					$GLOBALS['pas_transaction_id'] = $transaction_id;
					$GLOBALS['pas_transaction_id2'] = $transaction_id2;
					$GLOBALS['pas_subscription_key'] = $subscription_key;
					$GLOBALS['pas_fault'] = $fault;
					global $pas_transaction;
					$pas_transaction = array();
					$pas_transaction['pas_payment_status'] = $payment_status;
					$pas_transaction['pas_transaction_id'] = $transaction_id;
					$pas_transaction['pas_transaction_id2'] = $transaction_id2;
					$pas_transaction['pas_subscription_key'] = $subscription_key;
					$pas_transaction['pas_fault'] = $fault;
				
		
					if ($payment_status == 'completed') 
					{
				
						$payment_data = array(
							'date'             => date('Y-m-d g:i:s'),
							'subscription'     => $subscription_name,
							'payment_type'     => $payment_method,
							'subscription_key' => $subscription_key,
							'amount'           => $amount,
							'user_id'          => $user_id,
							'transaction_id'   => $transaction_id
						);
					
						//Action For pas or RCP Developers...
						do_action( 'RCP_pas_Insert_Payment', $payment_data, $user_id );
					
						$rcp_payments = new RCP_Payments();
						$rcp_payments->insert( $payment_data );
					
					
						$new_subscription_id = get_user_meta( $user_id, 'rcp_subscription_level_new' , true );
						if ( !empty( $new_subscription_id )) {
							update_user_meta( $user_id, 'rcp_subscription_level', $new_subscription_id );
						}
						rcp_set_status( $user_id, 'active' );
					
						
						if( version_compare( RCP_PLUGIN_VERSION, '2.1.0', '<' ) ) {
							rcp_email_subscription_status( $user_id, 'active' );
							if( ! isset( $rcp_options['disable_new_user_notices'] ) )
								wp_new_user_notification( $user_id );
						}
					
						update_user_meta( $user_id, 'rcp_payment_profile_id', $user_id );
					
						update_user_meta( $user_id, 'rcp_signup_method', 'live' );
						//rcp_recurring is just for paypal or ipn gateway
						update_user_meta( $user_id, 'rcp_recurring', 'no' ); 
					
						$subscription = rcp_get_subscription_details( rcp_get_subscription_id( $user_id ) );
						$member_new_expiration = date( 'Y-m-d H:i:s', strtotime( '+' . $subscription->duration . ' ' . $subscription->duration_unit . ' 23:59:59' ) );
						rcp_set_expiration_date( $user_id, $member_new_expiration );	
						delete_user_meta( $user_id, '_rcp_expired_email_sent' );
									
						$log_data = array(
							'post_title'    => __( 'تایید پرداخت', 'rcp_pas' ),
							'post_content'  => 'پرداخت با موفقیت انجام شد . رسید دیجیتال : '.$transaction_id.' کد پیگیری درگاه :'.$transaction_id2.__( ' .  روش پرداخت : ', 'rcp_pas' ).$payment_method,
							'post_parent'   => 0,
							'log_type'      => 'gateway_error'
						);

						$log_meta = array(
							'user_subscription' => $subscription_name,
							'user_id'           => $user_id
						);
						
						$log_entry = WP_Logging::insert_log( $log_data, $log_meta );
				

						//Action For pas or RCP Developers...
						do_action( 'RCP_pas_Completed', $user_id );				
					}	
						

					if ($payment_status == 'failed') 
					{
									
						$log_data = array(
							'post_title'    => __( 'خطا در پرداخت', 'rcp_pas' ),
							'post_content'  =>  __( 'تراکنش به دلیل خطای رو به رو ناموفق باقی باند :', 'rcp_pas' ).'"'.$fault.'"'.__( ' روش پرداخت : ', 'rcp_pas' ).$payment_method,
							'post_parent'   => 0,
							'log_type'      => 'gateway_error'
						);

						$log_meta = array(
							'user_subscription' => $subscription_name,
							'user_id'           => $user_id
						);
						
						$log_entry = WP_Logging::insert_log( $log_data, $log_meta );
					
						//Action For pas or RCP Developers...
						do_action( 'RCP_pas_Failed', $user_id );	
					
					}
			
				}
				add_filter( 'the_content', array($this,  'pas_Content_After_Return') );
				//session_destroy();	
			}
		}
		 
		
		public function pas_Content_After_Return( $content ) { 
			
			global $pas_transaction, $new;
			
			@session_start();
			
			$new_payment = isset($GLOBALS['pas_new']) ? $GLOBALS['pas_new'] : $new;
			
			$payment_status = isset($GLOBALS['pas_payment_status']) ? $GLOBALS['pas_payment_status'] : $pas_transaction['pas_payment_status'];
			$transaction_id = isset($GLOBALS['pas_transaction_id']) ? $GLOBALS['pas_transaction_id'] : $pas_transaction['pas_transaction_id'];
			$transaction_id2 = isset($GLOBALS['pas_transaction_id2']) ? $GLOBALS['pas_transaction_id2'] : $pas_transaction['pas_transaction_id2'];
			$fault = isset($GLOBALS['pas_fault']) ? ($GLOBALS['pas_fault']) : ($pas_transaction['pas_fault']);
			
			if ($new_payment == 1) 
			{
			
				$pas_data = array(
					'payment_status'             => $payment_status,
					'transaction_id'     => $transaction_id,
					'transaction_id2'     => $transaction_id2,
					'fault'     => $fault
				);
				

				$_SESSION["pas_data"] = json_encode($pas_data);	
			
			}
			else
			{
				 
				$pas_payment_data = isset($_SESSION["pas_data"]) ? json_decode($_SESSION["pas_data"],true) : '';
			
				$payment_status = isset($pas_payment_data['payment_status']) ? $pas_payment_data['payment_status'] : '';
				$transaction_id = isset($pas_payment_data['transaction_id']) ? $pas_payment_data['transaction_id'] : '';
				$transaction_id2 = isset($pas_payment_data['transaction_id2']) ? $pas_payment_data['transaction_id2'] : '';
				
				$fault = isset($pas_payment_data['fault']) ? '' : '';
			}
			
			$message = '';
			
			if ($payment_status == 'completed') {
				$message = '<br/>پرداخت با موفقیت انجام شد . رسید دیجیتال : '.$transaction_id.' کد پیگیری درگاه :'.$transaction_id2.'<br/>';
			}
			
			if ($payment_status == 'cancelled') {
				$message = '<br/>'.__( 'تراکنش به دلیل انصراف شما نا تمام باقی ماند .', 'rcp_pas' );
			}
			
			if ($payment_status == 'failed') {
				$message = '<br/>'.__( 'تراکنش به دلیل خطای زیر ناموفق باقی باند :', 'rcp_pas' ).'<br/>'.$fault.'<br/>';
			}
			
			return $content.$message;
		}
		

		
	}
}
new RCP_pas();
if ( !function_exists('change_cancelled_to_pending')) {	
	add_action( 'rcp_set_status', 'change_cancelled_to_pending', 10, 2 );
	function change_cancelled_to_pending( $status, $user_id ) {
		if( 'cancelled' == $status )
			rcp_set_status( $user_id, 'expired' );
			return true;
	}
}

if ( !function_exists('RCP_User_Registration_Data') && !function_exists('RCP_User_Registration_Data') ) {
	add_filter('rcp_user_registration_data', 'RCP_User_Registration_Data' );	
	function RCP_User_Registration_Data( $user ) {
		$old_subscription_id = get_user_meta( $user['id'], 'rcp_subscription_level' , true );
		if ( !empty( $old_subscription_id )) {
			update_user_meta( $user['id'], 'rcp_subscription_level_old', $old_subscription_id );
		}
		return $user;
	}
}
?>